#!/usr/bin/perl -w
# requires Perl version 5.8.0 later.
# This script is written by UTF-8.
# 2005-03-02 [STABLE] release.
# 2010-06-24 [STABLE] UTF-8 -> iso-2022-jp 文字化け対応
# 2010-11-02 [Update] フォーム入力不備の時に、再入力を促すテンプレートを使用するように変更
# 2010-11-24 [-TEST-] 送信メールの書式を iso-2022-jp + base64 から UTF-8 + base64 に更新。
#                     → 根本的な解決ではない。
# 2010-11-25 [STABLE] use utf8 を禁止してみる。
#                     mielw.pl を use MIME::Base64; にする。
#                     utf8統一により、use Encode も廃止。
#                     本文を iso-2022-jp にエンコードするように改訂。



# ！！　カレントフォルダにフォルダ名 Unicode を作成し、Japanese.pm を入れておく必要があります。
# ！！　カレントフォルダに mimew.pl が必要です。
# ！！　utf8 ですべて統一するなら use utf8 は禁止！
# 　　　送信テキストが380～400字ごとに化ける不具合が発生する。

####### use utf8;

# 自前で用意したモジュール(.pm)を検索できるようにする。
use constant LIB_DIR => '/usr/local/asuka/virtual/S4Z001618/files/htdocs_taxcom.co.jp/CPAN/';
use lib LIB_DIR;

use strict;
use warnings;

## デバッグ用のオプション
#use CGI::Carp qw (fatalsToBrowser);
#use CGI;

# メール送信フォーマット向けへ一括で MIME64 エンコードするためのモジュール。
require 'mimew.pl';

# カレントフォルダに Unicode フォルダを作成し、Japanese.pm を入れておく。
use Unicode::Japanese; # utf8 から jis, sjis, euc等へ変換するためのパッケージ。


################################################################

	# 初期化（セキュリティ確保）処理
	$ENV{'PATH'} = "/bin:/usr/bin";# 最低限のPATHだけに初期化
	delete @ENV{'IFS', 'CDPATH', 'ENV', 'BASH_ENV'};# 不要な環境変数を削除
	$CGI::DISABLE_UPLOADS = 1; # データのアップロード機能を無効に
	$CGI::POST_MAX = 10240; # POSTデータのサイズの上限を10KBに

################################################################

# main
{
	# 初期パラメータのプリセット
    my $input_form = './inquiry.html'; # 入力フォームHTMLへのパス＋ファイル名
    my $replace_form = './inquiry_replace.html'; # 入力項目に不備がある場合に再入力を促すためのフォーム
    my $verify_form = './inquiry_chk.html'; # 送信内容確認フォームHTMLへのパス＋ファイル名
    my $sendmail_ok = './sendmail_ok.html'; # 送信成功時のサンクスページ

	my $sendmail = '/usr/sbin/sendmail'; # sendmail の場所を設定する
	my $mailto = 'info@taxcom.co.jp'; # フォームメールの送信先アドレス
	my $mail_subject = '【HPより発注】「６代目円楽と税を考える」'; # 送信メールのタイトル

	my $form_str; # 画面へ出力するHTMLデータを入れる器

    my $submitdata = &get_SubmitData;
    my $hash_ref = &get_FormData($submitdata);
    my %form = %$hash_ref;

    my $number = $form{'number'};
    my $name = $form{'name'};
    my $name_kana = $form{'name_kana'};
	my $corp = $form{'corp'};
	my $corp_kana = $form{'corp_kana'};
	my $zip = $form{'zip'};
	my $address = $form{'address'};
	my $phone = $form{'phone'};
	my $fax = $form{'fax'};
    my $mail_address = $form{'mail_address'};
	my $comm = $form{'comment'};

    my $state = $form{'state'};


	# ステート情報がない場合には、入力フォームを出力するステートをセットする
	if($state eq ""){$state = 'INQUIRY';}

    my $data_requires = 0; # 入力フォームから受け取ったデータに誤りがあると、ゼロ以外の値が入る。
    my $err_message; # エラー画面に表示する警告文を入れておく受け皿。

	if($state eq "VERIFY"){
 		# 入力フォームからデータが投入された場合
		# 入力必須項目のチェック
		if($number < 1 ){$data_requires = 1;	$err_message .= "お買い求めになる書籍の「冊数」を選択してください。<br>";}
		if($name eq ""){$data_requires = 1;	$err_message .= "「代表者名」を入力してください。<br>";}
		if($zip eq ""){$data_requires = 1;	$err_message .= "「郵便番号」を入力してください。<br>";}
		if($address eq ""){$data_requires = 1;	$err_message .= "「住所」を入力してください。<br>";}
		if($phone eq ""){$data_requires = 1;	$err_message .= "「電話番号」を入力してください。<br>";}
		if($mail_address eq ""){$data_requires = 1;	$err_message .= "「メールアドレス」を入力してください。<br>";}


		#エラーがあれば、改行タグを追加する。
		if($data_requires eq "1"){$err_message .= '<br>';}

	} # if

	if($data_requires eq "1"){
		# 再入力用のフォームHTMLを読み込む
		open REPLACE_FORM, "< $replace_form" or die "Can't open file :$!";
			while(<REPLACE_FORM>){$form_str .= $_ };
		close REPLACE_FORM;
			# HTMLデータを出力する
	}elsif($state eq "INQUIRY"){
		# 入力フォームHTMLを読み込む
		open INPUT_FORM, "< $input_form" or die "Can't open file :$!";
			while(<INPUT_FORM>){$form_str .= $_ };
		close INPUT_FORM;
	}elsif($state eq "SEND_to_MAIL"){
		# 送信完了画面のHTMLデータを読み込む
		open INPUT_VERIFY, "< $sendmail_ok" or die "Can't open file :$!";
			while(<INPUT_VERIFY>){$form_str .= $_ };
		close INPUT_VERIFY;
	}elsif($state ne "SEND_to_MAIL"){
 		# 送信データ確認用のHTMLを読み込む
		open INPUT_VERIFY, "< $verify_form" or die "Can't open file :$!";
			while(<INPUT_VERIFY>){$form_str .= $_ };
		close INPUT_VERIFY;
	} # if

	# 入力フォームのデータを出力するHTMLデータに埋め込む
	$form_str =~ s/###NUMBER###/$number/g;
	$form_str =~ s/###NAME###/$name/g;
	$form_str =~ s/###NAME_KANA###/$name_kana/g;
	$form_str =~ s/###CORP###/$corp/g;
	$form_str =~ s/###CORP_KANA###/$corp_kana/g;
	$form_str =~ s/###ZIP###/$zip/g;
	$form_str =~ s/###ADDRESS###/$address/g;
	$form_str =~ s/###PHONE###/$phone/g;
	$form_str =~ s/###FAX###/$fax/g;
	$form_str =~ s/###MAIL_ADDRESS###/$mail_address/g;
	$form_str =~ s/###COMMENT###/$comm/g;
	$form_str =~ s/###ERROR_MESSAGE###/$err_message/g;

	if($state eq "VERIFY" or $state eq "SEND_to_MAIL"){
		my $comm_display = $comm;
		$comm_display = &crlf2br($comm_display);
		$form_str =~ s/###COMMENT_DISPLAY###/$comm_display/g;
	} # if

	# 入力データのステートがメール送信を要求している場合には、送信作業を行なう
	if($state eq "SEND_to_MAIL"){
		$form{'sendmail'} = $sendmail;
		$form{'mailto'} = $mailto;
		$form{'mail_subject'} = $mail_subject;
		
		# メール送信処理
		&send2mail(\%form);

	} # if


	# HTMLデータを出力する
	print "content-type:text/html\n\n";
	print $form_str;

	exit;

} # main


sub get_SubmitData
{
    my $data;
    my $method = $ENV{'REQUEST_METHOD'};

    if($method eq "GET")
    {
        $data = $ENV{'QUERY_STRING'};
    }
    elsif($method eq "POST")
    {
        read(STDIN,$data,$ENV{'CONTENT_LENGTH'});
    }

    return $data;
}

sub get_FormData
{
    my $data = shift;
    my @pair = split(/&/,$data);
    my %hash;

    foreach(@pair)
    {
        my($key,$value) = split(/=/);

		$key = &uri_decode($key);
		$value = &uri_decode($value);

		$key = &tag_escape($key);
		$value = &tag_escape($value);

        $hash {$key} = $value;

    }

    return \%hash;
}

sub uri_decode
{
        my $str = shift;

        $str =~ s/\+/ /g;
        $str =~ s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
        return $str;
}

sub tag_escape
{
        my $str = shift;

        $str =~ s/&/&amp;/g;
        $str =~ s/</&lt;/g;
        $str =~ s/>/&gt;/g;
        $str =~ s/"/&quot;/g;
        $str =~ s/'/&#39;/g;
        return $str;
}

sub tag_unescape
{
        my $str2 = shift;

        $str2 =~ s/&lt;/</g;
        $str2 =~ s/&gt;/>/g;
        $str2 =~ s/&quot;/"/g;
        $str2 =~ s/&#39;/'/g;
        $str2 =~ s/&amp;/&/g;

        return $str2;
}

sub crlf2br
{
	my $str = shift;

	# 改行コードをUNIXのLFに統一する処理
		# CR+LF(windows)かCR(mac)の並びをLF(unix)に置き換える。
		# CR = \x0D
		# LF = \x0A

		$str =~ s/\x0D\x0A/<br>/g;
		$str =~ s/\x0D/<br>/g;
		$str =~ s/\x0A/<br>/g;

	return $str;
}

sub send2mail{

	my $form_ref = shift;
	my %form = %{$form_ref};

	# データをハッシュから変数に展開
    my $number = $form{'number'};
    my $name = $form{'name'};
    my $name_kana = $form{'name_kana'};
	my $corp = $form{'corp'};
	my $corp_kana = $form{'corp_kana'};
	my $zip = $form{'zip'};
	my $address = $form{'address'};
	my $phone = $form{'phone'};
	my $fax = $form{'fax'};
    my $mail = $form{'mail_address'};
	my $comment = $form{'comment'};

    my $state = $form{'state'};
    
	my $sendmail = $form{'sendmail'};
	my $mailto = $form{'mailto'};
	my $mail_subject = $form{'mail_subject'};

	# メールのタイトルが無い場合には、題名をセットする
	if($mail_subject eq ""){$mail_subject = "【HPより送信】お問い合わせ";}

	# メールのタイトルを jis に変換する。
	my $jis_mail_subject = Unicode::Japanese->new($mail_subject)->jis;

	# MIMEw.pl を使ってメールタイトルにBASE64エンコードをかける
	my $mime_mail_subject = &mimeencode($jis_mail_subject);

	# 送信者名を jis に変換する。
	my $jis_name = Unicode::Japanese->new($name)->jis;

	# MIMEw.pl を使って名前にBASE64エンコードをかける
	my $mime_name = &mimeencode($jis_name);

# メールヘッダーの作成 （『Content-Transfer-Encording: 7bit』の後は２行改行する）

my $mail_header =<<MAIL_HEADER;
To: $mailto
From: $mime_name <$mail>
Subject: $mime_mail_subject
MIME-Version: 1.0
Content-type: text/plain; charset="iso-2022-jp"
Content-Transfer-Encording: 7bit


MAIL_HEADER

	# ホストへのアクセス情報を取得する
	my $remote_ip = $ENV{'REMOTE_ADDR'};
	my $remote_host = $ENV{'REMOTE_HOST'};

my $mail_data =<<MAIL_DATA;
========================================================
■ 書籍「６代目円楽と税を考える」の注文が入りました。
========================================================

購入冊数：$number 冊
--------------------------------------------------------

お名前：
$name

ふりがな：
$name_kana

メール：
$mail

--------------------------------------------------------

企業名：
$corp

企業名（ふりがな）：
$corp_kana

郵便番号
$zip

住所：
$address

電話番号：
$phone

ＦＡＸ：
$fax

--------------------------------------------------------

コメント：

$comment

========================================================
$remote_ip, $remote_host
MAIL_DATA

	# メール本文を jis に変換する。
	my $ jis_mail_body = Unicode::Japanese->new($mail_data)->jis;

	# サーバーに sendmail が存在するかをチェック
	&errorpage("sendmail がありません。") unless(-x $sendmail);

	# メール送信処理
	&errorpage() unless(open(MAIL, "| $sendmail -t -oi > /dev/null"));
	&errorpage() unless(print MAIL $mail_header . $jis_mail_body);
	close(MAIL);

} # send2mail

sub errorpage
{
	print "content-type: text/html\n\n";
	print "メール送信に失敗しました。\n";
	exit;
}

1;
